#ifndef _POSIX_PTHREAD_H
#define _POSIX_PTHREAD_H

//#include <_types.h>
#ifndef __POSIX_LIB__
//#include <pthread_impl.h>
#endif
#include <sched.h>
#include <time.h>
#include <sys/cdefs.h>

/*MirOS Manual: pthread_main_np(3)
PTHREAD_MAIN_NP(3)         BSD Programmer's Manual          PTHREAD_MAIN_NP(3)

NAME
     pthread_main_np - identify the main thread

SYNOPSIS
     #include <pthread.h>
     #include <pthread_np.h>

     int
     pthread_main_np(void);

DESCRIPTION
     The pthread_main_np() function identifies the main thread.

RETURN VALUES
     The pthread_main_np() function returns:

     1     if the calling thread is the main thread

     0     if the calling thread is not the main thread

     -1    if the thread initialization has not completed

SEE ALSO
     pthread_self(3), pthreads(3)

STANDARDS
     The pthread_main_np() function is non-portable and may not be supported
     with the above semantics on other POSIX systems.

MirOS BSD #10                  August 17, 2001                               */
     int
     pthread_main_np(void);


#endif