#import <AppKit/NSDocument.h>

@class NSCloseCommand;
@class NSScriptCommand;
@class NSScriptObjectSpecifier;
@class NSString;

@interface NSDocument (NSScripting)

/*objectSpecifier

Returns an object specifier for the document.

- (NSScriptObjectSpecifier *)objectSpecifier
Return Value

The document object specifier.
Discussion

An object specifier represents an AppleScript reference form, which is a natural-language expression such as words 10 through 20 or front document. During script processing, an object contained by a document (such as the second paragraph or the third rectangle) may need to specify its container (the document).
Availability
Available in Mac OS X v10.0 and later.*/
- (NSScriptObjectSpecifier *)objectSpecifier;

@end
