
#ifndef DRCORESTATUS_H
#define DRCORESTATUS_H

#if PRAGMA_ONCE
#pragma once
#endif

#ifndef CORESERVICES_H
#include <CoreServices/CoreServices.h>
#endif

#ifndef AVAILABILITYMACROS_H
#include <AvailabilityMacros.h>
#endif

/*kDRStatusStateErasing


The disc is being erased. 
extern const CFStringRef kDRStatusStateErasing;  
Discussion 

A value for the kDRStatusStateKey key in the erase status dictionary. This value indicates the erase is currently in progress. 
Availability
Introduced in Mac OS X v10.2*/
extern const CFStringRef kDRStatusStateErasing;  

/*kDRStatusStateVerifying


The burn or erase operation is being verified. 
extern const CFStringRef kDRStatusStateVerifying;  
Discussion 

A value for the kDRStatusStateKey dictionary key. This value indicates the operation is verifying what it did. 
Availability
Introduced in Mac OS X v10.2*/
extern const CFStringRef kDRStatusStateVerifying;  

/*kDRStatusStateTrackClose


The burn session is closing a track. 
extern const CFStringRef kDRStatusStateTrackClose;  
Discussion 

A value for the kDRStatusStateKey key in the burn status dictionary. This value indicates the burn engine is closing a track on disc. The number of the track being closed is available as the value for the kDRStatusCurrentTrackKey dictionary key. 
Availability
Introduced in Mac OS X v10.2*/
extern const CFStringRef kDRStatusStateTrackClose;  

/*kDRStatusStateSessionClose


The burn session is closing. 
extern const CFStringRef kDRStatusStateSessionClose;  
Discussion 

A value for the kDRStatusStateKey key in the burn status dictionary. This value indicates the burn engine is closing a session on disc. The number of the session being closed is available as the value for the kDRStatusCurrentSessionKey dictionary key. 
Availability
Introduced in Mac OS X v10.2*/
extern const CFStringRef kDRStatusStateSessionClose;  

/*kDRStatusStateTrackWrite

The burn session is writing a track. 
extern const CFStringRef kDRStatusStateTrackWrite;  
Discussion 

A value for the kDRStatusStateKey key in the burn status dictionary. This value indicates the burn engine is writing a track on disc. The number of the track being written is available as the value for the in kDRStatusCurrentTrackKey dictionary key. 
Availability
Introduced in Mac OS X v10.2*/
extern const CFStringRef kDRStatusStateTrackWrite;  

/*kDRStatusStatePreparing


The burn or erase operation is preparing to begin. 
extern const CFStringRef kDRStatusStatePreparing;  
Discussion 

A value for the kDRStatusStateKey dictionary key. This value indicates the burn or erase operation is preparing to begin. 
Availability
Introduced in Mac OS X v10.2*/
extern const CFStringRef kDRStatusStatePreparing;  

/*kDRStatusStateFailed


The burn or erase operation failed. 
extern const CFStringRef kDRStatusStateFailed;  
Discussion 

A value for the kDRStatusStateKey dictionary key. This value indicates the burn or erase operation finished but failed. 
Availability
Introduced in Mac OS X v10.2*/
extern const CFStringRef kDRStatusStateFailed; 

/*kDRStatusStateDone


The burn or erase operation finished successfully. 
extern const CFStringRef kDRStatusStateDone;  
Discussion 

A value for the kDRStatusStateKey dictionary key. This value indicates the burn or erase operation finished and succeeded. 
Availability
Introduced in Mac OS X v10.2*/
extern const CFStringRef kDRStatusStateDone;  

/*kDRStatusStateKey


The state of the burn or erase operation. 
extern const CFStringRef kDRStatusStateKey;  
Discussion 

A key for the status dictionaries. The value of this key is a CFString object indicating the current state of the burn or erase operation. 
Availability
Introduced in Mac OS X v10.2*/
extern const CFStringRef kDRStatusStateKey;  

/*kDRStatusPercentCompleteKey


The burn or erase operation's percentage of completion. 
extern const CFStringRef kDRStatusPercentCompleteKey;  
Discussion 

A key for the status dictionaries. The value of this key is a CFNumber object containing the precentage of completion for the burn or erase operation, expressed as a foating point number from 0 to 1. 
Availability
Introduced in Mac OS X v10.2*/
extern const CFStringRef kDRStatusPercentCompleteKey;  

/*kDRStatusCurrentTrackKey


The number of the track being burned. 
extern const CFStringRef kDRStatusCurrentTrackKey;  
Discussion 

A key for the status dictionaries. The value of this key is a CFNumber object containing the number of the track being burned. 
Availability
Introduced in Mac OS X v10.2*/
extern const CFStringRef kDRStatusCurrentTrackKey;  

#endif


