#import <Foundation/NSObject.h>

@interface NSScriptCoercionHandler : NSObject 

/*sharedCoercionHandler

Returns the shared NSScriptCoercionHandler for the application.

+ (NSScriptCoercionHandler *)sharedCoercionHandler
Return Value

The shared NSScriptCoercionHandler for the application.
Availability
Available in Mac OS X v10.0 and later.*/
+ (NSScriptCoercionHandler *)sharedCoercionHandler;

/*coerceValue:toClass:

Returns an object of a given class representing a given value. 

- (id)coerceValue:(id)value toClass:(Class)toClass
Parameters
value

The value to coerce.
toClass

The class with which to represent value.
Return Value

An object of the class toClass representing the value specified by value. Returns nil if an error occurs.
Availability
Available in Mac OS X v10.0 and later.*/
- (id)coerceValue:(id)value toClass:(Class)toClass;

@end
