#ifndef FINDERREGISTRY_H
#define FINDERREGISTRY_H

#ifndef APPLICATIONSERVICES_H
#include <ApplicationServices/ApplicationServices.h>
#endif

#ifndef OSA_H
#include <OpenScripting/OSA.h>
#endif

#include <AvailabilityMacros.h>

#if PRAGMA_ONCE
#pragma once
#endif

/*Finder Events


enum {
   kAECleanUp = 'fclu',
   kAEEject = 'ejct',
   kAEEmpty = 'empt',
   kAEErase = 'fera',
   kAEGestalt = 'gstl',
   kAEPutAway = 'ptwy',
   kAERebuildDesktopDB = 'rddb',
   kAESync = 'fupd',
   kAEInterceptOpen = 'fopn'
};*/
enum {
   kAECleanUp = 'fclu',
   kAEEject = 'ejct',
   kAEEmpty = 'empt',
   kAEErase = 'fera',
   kAEGestalt = 'gstl',
   kAEPutAway = 'ptwy',
   kAERebuildDesktopDB = 'rddb',
   kAESync = 'fupd',
   kAEInterceptOpen = 'fopn'
};


/*kAEFinderSuite


enum {
   kAEFinderSuite = 'fndr'
};*/
enum {
   kAEFinderSuite = 'fndr'
};

/*cAliasFile


enum {
   cAliasFile = 'alia',
   cApplicationFile = 'appf',
   cControlPanelFile = 'ccdv',
   cDeskAccessoryFile = 'dafi',
   cDocumentFile = 'docf',
   cFontFile = 'fntf',
   cSoundFile = 'sndf',
   cClippingFile = 'clpf',
   cContainer = 'ctnr',
   cDesktop = 'cdsk',
   cSharableContainer = 'sctr',
   cDisk = 'cdis',
   cFolder = 'cfol',
   cSuitcase = 'stcs',
   cAccessorySuitcase = 'dsut',
   cFontSuitcase = 'fsut',
   cTrash = 'ctrs',
   cDesktopPrinter = 'dskp',
   cPackage = 'pack',
   cContentSpace = 'dwnd',
   cContainerWindow = 'cwnd',
   cInfoWindow = 'iwnd',
   cSharingWindow = 'swnd',
   cStatusWindow = 'qwnd',
   cClippingWindow = 'lwnd',
   cPreferencesWindow = 'pwnd',
   cDTPWindow = 'dtpw',
   cProcess = 'prcs',
   cAccessoryProcess = 'pcda',
   cApplicationProcess = 'pcap',
   cGroup = 'sgrp',
   cUser = 'cuse',
   cSharingPrivileges = 'priv',
   cPreferences = 'cprf',
   cLabel = 'clbl',
   cSound = 'snd ',
   cAliasList = 'alst',
   cSpecialFolders = 'spfl',
   cOnlineDisk = 'cods',
   cOnlineLocalDisk = 'clds',
   cOnlineRemoteDisk = 'crds',
   cEntireContents = 'ects',
   cIconFamily = 'ifam'
};*/

enum {
   cAliasFile = 'alia',
   cApplicationFile = 'appf',
   cControlPanelFile = 'ccdv',
   cDeskAccessoryFile = 'dafi',
   cDocumentFile = 'docf',
   cFontFile = 'fntf',
   cSoundFile = 'sndf',
   cClippingFile = 'clpf',
   cContainer = 'ctnr',
   cDesktop = 'cdsk',
   cSharableContainer = 'sctr',
   cDisk = 'cdis',
   cFolder = 'cfol',
   cSuitcase = 'stcs',
   cAccessorySuitcase = 'dsut',
   cFontSuitcase = 'fsut',
   cTrash = 'ctrs',
   cDesktopPrinter = 'dskp',
   cPackage = 'pack',
   cContentSpace = 'dwnd',
   cContainerWindow = 'cwnd',
   cInfoWindow = 'iwnd',
   cSharingWindow = 'swnd',
   cStatusWindow = 'qwnd',
   cClippingWindow = 'lwnd',
   cPreferencesWindow = 'pwnd',
   cDTPWindow = 'dtpw',
   cProcess = 'prcs',
   cAccessoryProcess = 'pcda',
   cApplicationProcess = 'pcap',
   cGroup = 'sgrp',
   cUser = 'cuse',
   cSharingPrivileges = 'priv',
   cPreferences = 'cprf',
   cLabel = 'clbl',
   cSound = 'snd ',
   cAliasList = 'alst',
   cSpecialFolders = 'spfl',
   cOnlineDisk = 'cods',
   cOnlineLocalDisk = 'clds',
   cOnlineRemoteDisk = 'crds',
   cEntireContents = 'ects',
   cIconFamily = 'ifam'
};

/*pShowFolderSize


enum {
   pShowFolderSize = 'sfsz',
   pShowComment = 'scom',
   pShowDate = 'sdat',
   pShowCreationDate = 'scda',
   pShowKind = 'sknd',
   pShowLabel = 'slbl',
   pShowSize = 'ssiz',
   pShowVersion = 'svrs',
   pSortDirection = 'sord',
   pShowDiskInfo = 'sdin',
   pListViewIconSize = 'lvis',
   pGridIcons = 'fgrd',
   pStaggerIcons = 'fstg',
   pViewFont = 'vfnt',
   pViewFontSize = 'vfsz'
};*/
enum {
   pShowFolderSize = 'sfsz',
   pShowComment = 'scom',
   pShowDate = 'sdat',
   pShowCreationDate = 'scda',
   pShowKind = 'sknd',
   pShowLabel = 'slbl',
   pShowSize = 'ssiz',
   pShowVersion = 'svrs',
   pSortDirection = 'sord',
   pShowDiskInfo = 'sdin',
   pListViewIconSize = 'lvis',
   pGridIcons = 'fgrd',
   pStaggerIcons = 'fstg',
   pViewFont = 'vfnt',
   pViewFontSize = 'vfsz'
};

/*pCompletelyExpanded




enum {
   pCompletelyExpanded = 'pexc',
   pContainerWindow = cContainerWindow,
   pEntireContents = cEntireContents,
   pExpandable = 'pexa',
   pExpanded = 'pexp',
   pPreviousView = 'svew',
   pView = 'pvew',
   pIconSize = pListViewIconSize,
   pKeepArranged = 'arrg',
   pKeepArrangedBy = 'arby'
};*/
enum {
   pCompletelyExpanded = 'pexc',
   pContainerWindow = cContainerWindow,
   pEntireContents = cEntireContents,
   pExpandable = 'pexa',
   pExpanded = 'pexp',
   pPreviousView = 'svew',
   pView = 'pvew',
   pIconSize = pListViewIconSize,
   pKeepArranged = 'arrg',
   pKeepArrangedBy = 'arby'
};


/*pComment


enum {
   pComment = 'comt',
   pContainer = cContainer,
   pContentSpace = cContentSpace,
   pCreationDateOld = 'crtd',
   pCreationDate = 'ascd',
   pDescription = 'dscr',
   pDisk = cDisk,
   pFolderOld = cFolder,
   pFolder = 'asdr',
   pIconBitmap = 'iimg',
   pInfoWindow = cInfoWindow,
   pKind = 'kind',
   pLabelIndex = 'labi',
   pModificationDateOld = 'modd',
   pModificationDate = 'asmo',
   pPhysicalSize = 'phys',
   pPosition = 'posn',
   pIsSelected = 'issl',
   pSize = pPointSize,
   pWindow = cWindow,
   pPreferencesWindow = cPreferencesWindow
};*/
enum {
   pComment = 'comt',
   pContainer = cContainer,
   pContentSpace = cContentSpace,
   pCreationDateOld = 'crtd',
   pCreationDate = 'ascd',
   pDescription = 'dscr',
   pDisk = cDisk,
   pFolderOld = cFolder,
   pFolder = 'asdr',
   pIconBitmap = 'iimg',
   pInfoWindow = cInfoWindow,
   pKind = 'kind',
   pLabelIndex = 'labi',
   pModificationDateOld = 'modd',
   pModificationDate = 'asmo',
   pPhysicalSize = 'phys',
   pPosition = 'posn',
   pIsSelected = 'issl',
   pSize = pPointSize,
   pWindow = cWindow,
   pPreferencesWindow = cPreferencesWindow
};

/*pAboutMacintosh


enum {
   pAboutMacintosh = 'abbx',
   pAppleMenuItemsFolder = 'amnu',
   pControlPanelsFolder = 'ctrl',
   pDesktop = 'desk',
   pExtensionsFolder = 'extn',
   pFinderPreferences = 'pfrp',
   pFontsFolder = 'font',
   pFontsFolderPreAllegro = 'ffnt',
   pLargestFreeBlock = 'mfre',
   pPreferencesFolder = 'pref',
   pShortCuts = 'scut',
   pShutdownFolder = 'shdf',
   pStartupItemsFolder = 'strt',
   pSystemFolder = 'macs',
   pTemporaryFolder = 'temp',
   pViewPreferences = 'pvwp',
   pStartingUp = 'awak'
};*/
enum {
   pAboutMacintosh = 'abbx',
   pAppleMenuItemsFolder = 'amnu',
   pControlPanelsFolder = 'ctrl',
   pDesktop = 'desk',
   pExtensionsFolder = 'extn',
   pFinderPreferences = 'pfrp',
   pFontsFolder = 'font',
   pFontsFolderPreAllegro = 'ffnt',
   pLargestFreeBlock = 'mfre',
   pPreferencesFolder = 'pref',
   pShortCuts = 'scut',
   pShutdownFolder = 'shdf',
   pStartupItemsFolder = 'strt',
   pSystemFolder = 'macs',
   pTemporaryFolder = 'temp',
   pViewPreferences = 'pvwp',
   pStartingUp = 'awak'
};

/*typeIconFamily


enum {
   typeIconFamily = cIconFamily,
   typeIconAndMask = 'ICN#',
   type8BitMask = 'l8mk',
   type32BitIcon = 'il32',
   type8BitIcon = 'icl8',
   type4BitIcon = 'icl4',
   typeSmallIconAndMask = 'ics#',
   typeSmall8BitMask = 's8mk',
   typeSmall32BitIcon = 'is32',
   typeSmall8BitIcon = 'ics8',
   typeSmall4BitIcon = 'ics4',
   typeRelativeTime = 'rtim',
   typeConceptualTime = 'timc'
};*/
enum {
   typeIconFamily = cIconFamily,
   typeIconAndMask = 'ICN#',
   type8BitMask = 'l8mk',
   type32BitIcon = 'il32',
   type8BitIcon = 'icl8',
   type4BitIcon = 'icl4',
   typeSmallIconAndMask = 'ics#',
   typeSmall8BitMask = 's8mk',
   typeSmall32BitIcon = 'is32',
   typeSmall8BitIcon = 'ics8',
   typeSmall4BitIcon = 'ics4',
   typeRelativeTime = 'rtim',
   typeConceptualTime = 'timc'
};



#endif