#import <Foundation/Foundation.h>
#import <QuickTime/QuickTime.h>
#import <QTKit/QTKitDefines.h>
#import <QTKit/QTTime.h>

/*QTTimeRange

Defines a range of time. 

typedef struct {     QTTime time;     QTTime duration; } QTTimeRange;
Discussion

The QTTimeRange structure defines a range of time. It is used, for instance, to specify the active segment of a movie or track. The QTKit provides a number of functions for converting and comparing QTTimeRange structures.*/
typedef struct {   
  QTTime time; 
   QTTime duration; 
} QTTimeRange;

/*QTMakeTimeRange

Returns a QTTimeRange structure initialized using the QTTime structures time and duration.

QTTimeRange QTMakeTimeRange(QTTime time, QTTime duration);
Discussion

This function returns a QTTimeRange structure initialized using the QTTime structures time and duration. Those structures may have different time scales. In all cases, the time scale used in the new QTTimeRange structure is that of time.
Availability
Available in Mac OS X v10.3 and later.*/
QTTimeRange QTMakeTimeRange(QTTime time, QTTime duration);



//@interface NSValue (NSValueQTTimeRangeExtensions)
//@end

//@interface NSCoder (NSQTTimeRangeCoding)
//@end
