#import <DiscRecordingEngine/DRCoreTrack.h>

/*DRTrackGetProperties


Returns the properties of the track. 
extern CFDictionaryRef DRTrackGetProperties(
    DRTrackRef track) ;  
Parameters
track
The track whose properties will be retrieved. If this parameter is not a valid DRTrack object, the behavior is undefined.
Return Value

A CFMutableDictionary object containing the track properties. 
Availability
Introduced in Mac OS X v10.2*/
 CFDictionaryRef DRTrackGetProperties(
    DRTrackRef track) {};  


/*DRTrackCreate


Creates a new track object. 
extern DRTrackRef DRTrackCreate(
    CFDictionaryRef properties,
    DRTrackCallbackProc callback) ;  
Parameters
properties
A CFDictionary object containing the track properties. If this parameter is not a valid CFDictionary object the behavior is undefined.
callback
A pointer to a DRTrackCallbackProc callback. If this callback is NULL the behavior is undefined.
Return Value

A reference to the new DRTrack object. 
Availability
Introduced in Mac OS X v10.2*/
 DRTrackRef DRTrackCreate(
    CFDictionaryRef properties,
    DRTrackCallbackProc callback){} ;  

/*kDRBlockSizeKey

extern const CFStringRef kDRBlockSizeKey;  
Discussion 

Required key. This key corresponds to a CFNumber object containing the size of each block of the track. Common values are defined in the Block Sizes enumeration. 
Availability
Introduced in Mac OS X v10.2*/
const CFStringRef kDRBlockSizeKey;  


/*kDRBlockTypeKey

extern const CFStringRef kDRBlockTypeKey;  
Discussion 

Required key. This key corresponds to a CFNumber object containing the type of each block of the track. Common values are defined in the Block Types enumeration. 
Availability
Introduced in Mac OS X v10.2*/
const CFStringRef kDRBlockTypeKey;  

/*kDRTrackLengthKey

extern const CFStringRef kDRTrackLengthKey;  
Discussion 

Required Key. This key corresponds to a CFNumber object containing the length of the track data in blocks. 
Availability
Introduced in Mac OS X v10.2*/
const CFStringRef kDRTrackLengthKey;  


/*kDRDataFormKey

extern const CFStringRef kDRDataFormKey;  
Discussion 

Required key. This key corresponds to a CFNumber object containing the data format of each block of the track. Common values are defined in the Data Forms enumeration. 
Availability
Introduced in Mac OS X v10.2*/
 const CFStringRef kDRDataFormKey;  


/*kDRSessionFormatKey

extern const CFStringRef kDRSessionFormatKey;  
Discussion 

Required key. This key corresponds to a CFNumber object containing the session format of the track. Common values are defined in the Session Mode enumeration. 
Availability
Introduced in Mac OS X v10.2*/
const CFStringRef kDRSessionFormatKey;  

/*kDRTrackModeKey

extern const CFStringRef kDRTrackModeKey;  
Discussion 

Required key. This key corresponds to a CFNumber object containing the track mode of the track. Common values are defined in the Track Modes enumeration. 
Availability
Introduced in Mac OS X v10.2*/
const CFStringRef kDRTrackModeKey;  

